<!doctype html>
<html lang="en">
<head>
<title>86-pkg-config-pkgconf-bof</title>
<meta name="generator" content="Etherpad">
<meta name="author" content="Etherpad">
<meta name="changedby" content="Etherpad">
<meta charset="utf-8">
<style>
ol {
  counter-reset: item;
}

ol > li {
  counter-increment: item;
}

ol ol > li {
  display: block;
}

ol > li {
  display: block;
}

ol > li:before {
  content: counters(item, ".") ". ";
}

ol ol > li:before {
  content: counters(item, ".") ". ";
  margin-left: -20px;
}

ul.indent {
  list-style-type: none;
}


</style>
</head>
<body>
<span class="anonymous" title="anonymous">pkg-config / pkgconf BoF</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="anonymous" title="anonymous">This BoF is to discuss the state of pkg-config and pkgconf in Debian, and the proposal to switch from pkg-config to pkgconf: its benefits and downsides, approaches etc.</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="anonymous" title="anonymous">pkgconf</span><span class="anonymous" title="anonymous"> is a newer, actively maintained implementation of pkg-config that supports more aspects of the pkg-config file specification and provides a library interface that applications can use to incorporate intelligent handling of pkg-config files into themselves (such as build file generators, IDEs, and compilers). Through its pkg-config compatibility interface (activated when it is run as "pkg-config"), it also can completely replace the original implementation.</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="anonymous" title="anonymous">Debian would benefit from switching to pkgconf by utilising a more complete implementation of pkg-config that handles aspects of .pc files that pkg-config does not. For example, Provides rules and Cflags.private rules are supported, and pkgconf has a better (and less costly) dependency resolver for .pc files.</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="anonymous" title="anonymous">pkgconf doesn’t depend on glib, making it easier to bootstrap new architectures, since there won't be a cyclic dependency to break (pkg-config → glib → pkg-config).</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><ul class="bullet"><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">http://pkgconf.org/features.html</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">https://fedoraproject.org/wiki/Changes/pkgconf_as_system_pkg-config_implementation</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">https://packages.gentoo.org/packages/virtual/pkgconfig/dependencies</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">Arch replaced pkg-config wrapper scripts with pkgconf personality feature:</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><ul class="bullet"><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">https://archlinux.org/packages/core/x86_64/pkgconf/</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="anonymous" title="anonymous">https://github.com/archlinux/svntogit-packages/commit/d5437566549e4a96f3bf965965f47351ab0bb6ff</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span></ul><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Postgres and LLVM refuse to use pkg-config </span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">partly</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"> because it doesn’t support features they may need, but pkgconf seems to</span></ul><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Plan</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a"></span><br><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">0. DROP the dpkg hook.</span><br><ol start="1" class="number"><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Ack the binary package takeover with Tollef</span></ol><ul class="bullet"><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Only one implementation is preferrable to having both in Debian to prevent random failover modes</span></ul><ol start="3" class="number"><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">File a bug with the release team (a transition).</span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Replace in experimental</span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Rebuild, find issues, send patches</span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">…</span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">Upload to unstable</span></li><li><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">*</span><span class="a_LIgJsnRlNqyclhIe" title="a_LIgJsnRlNqyclhIe" style="background-color:#cb0b4a">PROFIT!</span><span class="anonymous" title="anonymous"></span></ol>
</body>
</html>
